commit 7e7a1b612654479e821214f7ef7658de8a132714
Author: Jason Merrill <jason@redhat.com>
Date:   Sat Feb 15 10:48:17 2025 +0100

    c++: NRVO, constexpr, lambda [PR118053]
    
    Here during constant evaluation we encounter a VAR_DECL with DECL_VALUE_EXPR
    of the RESULT_DECL, where the latter has been adjusted for
    pass-by-invisible-reference.  We already had the code to deal with this, we
    just need to use it in the non-capture case of DECL_VALUE_EXPR as well.
    
            PR c++/118053
    
    gcc/cp/ChangeLog:
    
            * constexpr.cc (cxx_eval_constant_expression): Generalize
            DECL_VALUE_EXPR invisiref handling.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/cpp1y/constexpr-lambda1.C: New test.
    
    (cherry picked from commit de66529f2e7bb24fb2b61b82e6a953f3f6c12902)

diff --git a/gcc/testsuite/g++.dg/cpp1y/constexpr-lambda1.C b/gcc/testsuite/g++.dg/cpp1y/constexpr-lambda1.C
new file mode 100644
index 00000000000..dca3920ddc0
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp1y/constexpr-lambda1.C
@@ -0,0 +1,21 @@
+// PR c++/118053
+// { dg-do compile { target c++14 } }
+// { dg-additional-options -O }
+
+template <typename _Tp> struct vector {
+  _Tp * _M_finish;
+  vector(_Tp);
+  vector(const vector &);
+  constexpr auto back() { return *_M_finish; }
+};
+template <typename Funct> void
+run(Funct funct) { funct(1); }
+
+vector<int>
+runner() try {
+  vector<int> vec{1};
+  run([&](auto) { vec.back(); });
+  return vec;
+} catch (...) {
+  return 1;
+}

